default:
  image: {{DOCKER_AWS_CLI_IMG}}

include:
  - remote: {{CI_FILES_DOMAIN}}/common/build.yml


variables:
  ECR_BASE: {{ECR_BASE}}
  ECR_IMAGE: $ECR_BASE/$COMPONENT_NAME

stages:
  - deploy

build-and-deploy:
  stage: deploy
  only:
    - /^release\/[0-9]+(?:.[0-9]+)+$/ # regular expression
  script:
    - !reference [.common, ecr-public-login]
    - source VARIABLES
    - RELEASE=${CI_COMMIT_BRANCH#"release/"}
    - docker build $(cat VARIABLES | sed 's@^@--build-arg @g' | paste -s -d " ") -t $ECR_IMAGE:commit-$CI_COMMIT_SHORT_SHA .
    - docker tag $ECR_IMAGE:commit-$CI_COMMIT_SHORT_SHA $ECR_IMAGE:commit-$RELEASE-$CI_COMMIT_SHORT_SHA
    - docker push $ECR_IMAGE:commit-$RELEASE-$CI_COMMIT_SHORT_SHA
    - docker push $ECR_IMAGE:commit-$CI_COMMIT_SHORT_SHA
    - docker rmi $ECR_IMAGE:commit-$RELEASE-$CI_COMMIT_SHORT_SHA
    - docker rmi $ECR_IMAGE:commit-$CI_COMMIT_SHORT_SHA


deploy-tag:
  stage: deploy
  rules:
    - if: $CI_COMMIT_TAG =~ /^v(?:\d+.){2}(?:\d+)$/ || $CI_COMMIT_TAG  =~ /^latest.*$/
  script:
    - !reference [.common, ecr-public-login]
    - docker pull $ECR_IMAGE:commit-$CI_COMMIT_SHORT_SHA
    - docker tag $ECR_IMAGE:commit-$CI_COMMIT_SHORT_SHA $ECR_IMAGE:$CI_COMMIT_TAG
    - docker push $ECR_IMAGE:$CI_COMMIT_TAG
    - docker rmi $ECR_IMAGE:$CI_COMMIT_TAG
    - docker rmi $ECR_IMAGE:commit-$CI_COMMIT_SHORT_SHA
